﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using Syncfusion.Mvc.DocIO.Web;
using System.Drawing;
using System.IO;

namespace GenerateWord.Controllers
{
    public class HomeController : Controller
    {
        string dataPath;
        #region Generate Word
        public ActionResult Index(string Group1)
        {
            if (Group1 == null)
                return View();

            dataPath = ResolveApplicationDataPath("\\", "Data");
            WordDocument document = new WordDocument();
            document.EnsureMinimal();
            //Initiating table object
            IWTable table = document.LastSection.AddTable();
            //Setting rows and columns
            table.ResetCells(100, 2);
            //Creating another table to inesrt in first row.
            IWTable table1 = document.LastSection.AddTable();
            table1.ResetCells(1, 1);
            //Adding second table in the first cell of first table
            table1.Rows[0].Cells[0].AddParagraph().AppendText("Static Table").CharacterFormat.Bold = true;
            table.Rows[0].Cells[0].ChildEntities.Add(table1);
            //Adding content in the second cell of first table.
            table.Rows[0].Cells[1].AddParagraph().AppendText("Header2").CharacterFormat.Bold = true;
            //Mark this rows as header row thereby it will be displayed in each and every pages.
            table.Rows[0].IsHeader = true;
            //Adding multiple rows to the table
            for (int i = 1; i < 100; i++)
            {
                table.Rows[i].Cells[0].AddParagraph().AppendText("Cell1");
                table.Rows[i].Cells[1].AddParagraph().AppendText("Cell2");
            }


            #region saveOption
            if (Group1 == "Word97To2003")
            {
                //Save as .doc Word 97-2003 format
                return document.ExportAsActionResult("Sample.doc", FormatType.Doc, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            //Save as .docx Word 2007 format
            else if (Group1 == "Word2007")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2007, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            //Save as .docx Word 2010 format
            else if (Group1 == "Word2010")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2010, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            //Save as .docx Word 2013 format
            else if (Group1 == "Word2013")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2013, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            #endregion saveOption

            return View();
        }
        #endregion Getting Started
        /// <summary>
        /// Data folder path is resolved from requested page physical path
        /// </summary>
        /// <param name="fileName"></param>
        /// <param name="folderName"></param>
        /// <returns></returns>
        protected string ResolveApplicationDataPath(string fileName, string folderName)
        {
            string dataPath = null;
            dataPath = Server.MapPath(@"App_Data//Images//").ToString();
            return string.Format("{0}\\{1}", dataPath, fileName);
        }
    }
}
